package org.apidesign.apifest08.test;

import static junit.framework.Assert.assertNotNull;
import static org.apidesign.apifest08.test.Task1Test.CZK;
import static org.apidesign.apifest08.test.Task1Test.USD;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.ConvertorFactory;
import org.apidesign.apifest08.currency.MoneyImpl;
import org.junit.Test;


public class ConvertorFactoryTest {
	@Test(expected=NullPointerException.class)
	public void testNullSource()
	{
		ConvertorFactory.createConvertor(null, new MoneyImpl(1,USD));
	}
	@Test(expected=NullPointerException.class)
	public void testNullDestination()
	{
		ConvertorFactory.createConvertor(new MoneyImpl(17,CZK), null);
	}
	@Test
	public void testOk()
	{
		assertNotNull(ConvertorFactory.createConvertor(new MoneyImpl(17,CZK),  new MoneyImpl(1,USD)));
	}
	@Test
	public void testOkDecimalRate()
	{
		Convertor c = ConvertorFactory.createConvertor(new MoneyImpl(1,CZK),  new MoneyImpl(1d/17d,USD));
		assertNotNull(c);
		assertEquals(new MoneyImpl(17,CZK),c.convert(new MoneyImpl(1,USD), CZK));
	}
	@Test
	public void testZeroEquivalentRate()
	{
		try
		{
			ConvertorFactory.createConvertor(new MoneyImpl(1,CZK),  new MoneyImpl(0,USD));
			fail("Exception expected");
		}
		catch(IllegalArgumentException e)
		{
			assertTrue("OK",true);
		}
	}
}
